import os
import logging
from pscr_common.metrics import get_reporter, PrometheusRegistry
from pscr_common.metadata import MetadataProvider

_logger = logging.getLogger(__name__)


class Metrics:
    def __init__(self, config):
        self.metrics_registry = PrometheusRegistry()
        env = os.environ.get("GLOBAL_ENV_NAME", "unknown")

        env_meta = MetadataProvider().get_metadata()

        service_mode = config.get("service", "mode")

        if service_mode == "LC":
            server_type = "org_mapper"
        else:
            server_type = "nta_mapper"

        self.reporter = get_reporter(
            self.metrics_registry,
            env,
            env_meta.task_id,
            server_type,
            env_meta.image.rsplit(":", maxsplit=1)[-1],
        )

    def start_reporter(self):
        if self.reporter:
            self.reporter.start()
